| Flutter Impeller |

Classes | Public Member Functions | Static Public Member Functions | List of all members
impeller::ContextVK Class Referencefinal

`#include <context_vk.h>`

Inheritance diagram for impeller::ContextVK:

## Classes
struct | Settings

## Public Member Functions
uint64_t | GetHash () const
| ~ContextVK () override
BackendType | GetBackendType () const override
| Get the graphics backend of an Impeller context. More...
std::string | DescribeGpuModel () const override
bool | IsValid () const override
| Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context. More...
std::shared_ptr< Allocator > | GetResourceAllocator () const override
| Returns the allocator used to create textures and buffers on the device. More...
std::shared_ptr< ShaderLibrary > | GetShaderLibrary () const override
| Returns the library of shaders used to specify the programmable stages of a pipeline. More...
std::shared_ptr< SamplerLibrary > | GetSamplerLibrary () const override
| Returns the library of combined image samplers used in shaders. More...
std::shared_ptr< PipelineLibrary > | GetPipelineLibrary () const override
| Returns the library of pipelines used by render or compute commands. More...
std::shared_ptr< CommandBuffer > | CreateCommandBuffer () const override
| Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device. More...
const std::shared_ptr< const Capabilities > & | GetCapabilities () const override
| Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`. More...
void | Shutdown () override
| Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops. More...
void | SetSyncPresentation (bool value) override
| Force the Vulkan presentation (submitKHR) to be performed on the raster task runner. More...
bool | GetSyncPresentation () const
void | SetOffscreenFormat (PixelFormat pixel_format)
template<typename T >
bool | SetDebugName (T handle, std::string_view label) const
std::shared_ptr< DeviceHolder > | GetDeviceHolder () const
vk::Instance | GetInstance () const
const vk::Device & | GetDevice () const
const std::shared_ptr< fml::ConcurrentTaskRunner > | GetConcurrentWorkerTaskRunner () const
std::shared_ptr< SurfaceContextVK > | CreateSurfaceContext ()
const std::shared_ptr< QueueVK > & | GetGraphicsQueue () const
vk::PhysicalDevice | GetPhysicalDevice () const
std::shared_ptr< FenceWaiterVK > | GetFenceWaiter () const
std::shared_ptr< ResourceManagerVK > | GetResourceManager () const
std::shared_ptr< CommandPoolRecyclerVK > | GetCommandPoolRecycler () const
Public Member Functions inherited from impeller::Context
virtual | ~Context ()
| Destroys an Impeller context. More...
virtual bool | UpdateOffscreenLayerPixelFormat (PixelFormat format)
Pool< HostBuffer > & | GetHostBufferPool () const
| Accessor for a pool of HostBuffers. More...

## Static Public Member Functions
static std::shared_ptr< ContextVK > | Create (Settings settings)
template<typename T >
static bool | SetDebugName (const vk::Device &device, T handle, std::string_view label)
Static Public Member Functions inherited from impeller::BackendCast< ContextVK, Context >
static ContextVK & | Cast (Context &base)
static const ContextVK & | Cast (const Context &base)
static ContextVK * | Cast (Context *base)
static const ContextVK * | Cast (const Context *base)

## Additional Inherited Members
Public Types inherited from impeller::Context
enum | BackendType { BackendType::kMetal, BackendType::kOpenGLES, BackendType::kVulkan }
Public Attributes inherited from impeller::Context
CaptureContext | capture
Protected Member Functions inherited from impeller::Context
| Context ()

## Detailed Description

Definition at line 36 of file context_vk.h.

## Constructor & Destructor Documentation

## ◆ ~ContextVK()

impeller::ContextVK::~ContextVK | ( |  | ) |
| override

Definition at line 112 of file context_vk.cc.

112 {
113 if (device_holder_ && device_holder_->device) {
114 [[maybe_unused]] auto result = device_holder_->device->waitIdle();
115 }
116 CommandPoolRecyclerVK::DestroyThreadLocalPools(this);
117 }

References impeller::CommandPoolRecyclerVK::DestroyThreadLocalPools().

## Member Function Documentation

## ◆ Create()

std::shared_ptr< ContextVK > impeller::ContextVK::Create | ( | Settings | settings | ) |
| static

Definition at line 92 of file context_vk.cc.

92 {
93 auto context = std::shared_ptr<ContextVK>(new ContextVK());
94 context->Setup(std::move(settings));
95 if (!context->IsValid()) {
96 return nullptr;
97 }
98 return context;
99 }

Referenced by impeller::PlaygroundImplVK::PlaygroundImplVK().

## ◆ CreateCommandBuffer()

std::shared_ptr< CommandBuffer > impeller::ContextVK::CreateCommandBuffer | ( |  | ) | const
| override virtual

Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device.

A command buffer can only be used on a single thread. Multi-threaded render, blit, or compute passes must create a new command buffer on each thread.

Returns
  A new command buffer.

Implements impeller::Context.

Definition at line 469 of file context_vk.cc.

469 {
470 return std::shared_ptr<CommandBufferVK>(
471 new CommandBufferVK(shared_from_this(), //
472 CreateGraphicsCommandEncoderFactory()) //
473 );
474 }

## ◆ CreateSurfaceContext()

std::shared_ptr< SurfaceContextVK > impeller::ContextVK::CreateSurfaceContext | ( |  | ) |

Definition at line 501 of file context_vk.cc.

501 {
502 return std::make_shared<SurfaceContextVK>(shared_from_this());
503 }

## ◆ DescribeGpuModel()

std::string impeller::ContextVK::DescribeGpuModel | ( |  | ) | const
| override virtual

Implements impeller::Context.

Definition at line 445 of file context_vk.cc.

445 {
446 return device_name_;
447 }

## ◆ GetBackendType()

Context::BackendType impeller::ContextVK::GetBackendType | ( |  | ) | const
| override virtual

Get the graphics backend of an Impeller context.

            This is useful for cases where a renderer needs to track and
            lookup backend-specific resources, like shaders or uniform
            layout information.

            It's not recommended to use this as a substitute for
            per-backend capability checking. Instead, check for specific
            capabilities via `GetCapabilities()`.

Returns
  The graphics backend of the `Context`.

Implements impeller::Context.

Definition at line 119 of file context_vk.cc.

119 {
120 return Context::BackendType::kVulkan;
121 }

References impeller::Context::kVulkan.

## ◆ GetCapabilities()

const std::shared_ptr< const Capabilities > & impeller::ContextVK::GetCapabilities | ( |  | ) | const
| override virtual

Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`.

Returns
  The capabilities. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 505 of file context_vk.cc.

505 {
506 return device_capabilities_;
507 }

## ◆ GetCommandPoolRecycler()

std::shared_ptr< CommandPoolRecyclerVK > impeller::ContextVK::GetCommandPoolRecycler | ( |  | ) | const

Definition at line 525 of file context_vk.cc.

526 {
527 return command_pool_recycler_;
528 }

## ◆ GetConcurrentWorkerTaskRunner()

const std::shared_ptr< fml::ConcurrentTaskRunner > impeller::ContextVK::GetConcurrentWorkerTaskRunner | ( |  | ) | const

Definition at line 485 of file context_vk.cc.

485 {
486 return raster_message_loop_->GetTaskRunner();
487 }

## ◆ GetDevice()

const vk::Device & impeller::ContextVK::GetDevice | ( |  | ) | const

Definition at line 480 of file context_vk.cc.

480 {
481 return device_holder_->device.get();
482 }

Referenced by impeller::AllocateAndBindDescriptorSets(), and SetDebugName().

## ◆ GetDeviceHolder()

std::shared_ptr<DeviceHolder> impeller::ContextVK::GetDeviceHolder | ( |  | ) | const
| inline

Definition at line 124 of file context_vk.h.

124 {
125 return device_holder_;
126 }

## ◆ GetFenceWaiter()

std::shared_ptr< FenceWaiterVK > impeller::ContextVK::GetFenceWaiter | ( |  | ) | const

Definition at line 517 of file context_vk.cc.

517 {
518 return fence_waiter_;
519 }

## ◆ GetGraphicsQueue()

const std::shared_ptr< QueueVK > & impeller::ContextVK::GetGraphicsQueue | ( |  | ) | const

Definition at line 509 of file context_vk.cc.

509 {
510 return queues_.graphics_queue;
511 }

References impeller::QueuesVK::graphics_queue.

## ◆ GetHash()

uint64_t impeller::ContextVK::GetHash | ( |  | ) | const
| inline

Definition at line 53 of file context_vk.h.

53 { return hash_; }

Referenced by impeller::CommandPoolRecyclerVK::DestroyThreadLocalPools().

## ◆ GetInstance()

vk::Instance impeller::ContextVK::GetInstance | ( |  | ) | const

Definition at line 476 of file context_vk.cc.

476 {
477 return *device_holder_->instance;
478 }

## ◆ GetPhysicalDevice()

vk::PhysicalDevice impeller::ContextVK::GetPhysicalDevice | ( |  | ) | const

Definition at line 513 of file context_vk.cc.

513 {
514 return device_holder_->physical_device;
515 }

## ◆ GetPipelineLibrary()

std::shared_ptr< PipelineLibrary > impeller::ContextVK::GetPipelineLibrary | ( |  | ) | const
| override virtual

Returns the library of pipelines used by render or compute commands.

Returns
  The pipeline library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 465 of file context_vk.cc.

465 {
466 return pipeline_library_;
467 }

## ◆ GetResourceAllocator()

std::shared_ptr< Allocator > impeller::ContextVK::GetResourceAllocator | ( |  | ) | const
| override virtual

Returns the allocator used to create textures and buffers on the device.

Returns
  The resource allocator. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 453 of file context_vk.cc.

453 {
454 return allocator_;
455 }

Referenced by impeller::AllocateAndBindDescriptorSets().

## ◆ GetResourceManager()

std::shared_ptr< ResourceManagerVK > impeller::ContextVK::GetResourceManager | ( |  | ) | const

Definition at line 521 of file context_vk.cc.

521 {
522 return resource_manager_;
523 }

## ◆ GetSamplerLibrary()

std::shared_ptr< SamplerLibrary > impeller::ContextVK::GetSamplerLibrary | ( |  | ) | const
| override virtual

Returns the library of combined image samplers used in shaders.

Returns
  The sampler library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 461 of file context_vk.cc.

461 {
462 return sampler_library_;
463 }

## ◆ GetShaderLibrary()

std::shared_ptr< ShaderLibrary > impeller::ContextVK::GetShaderLibrary | ( |  | ) | const
| override virtual

Returns the library of shaders used to specify the programmable stages of a pipeline.

Returns
  The shader library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 457 of file context_vk.cc.

457 {
458 return shader_library_;
459 }

## ◆ GetSyncPresentation()

bool impeller::ContextVK::GetSyncPresentation | ( |  | ) | const
| inline

Definition at line 91 of file context_vk.h.

91 { return sync_presentation_; }

## ◆ IsValid()

bool impeller::ContextVK::IsValid | ( |  | ) | const
| override virtual

Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context.

It is convention in Impeller to never return an invalid context from a call that returns an pointer to a context. The call implementation performs validity checks itself and return a null context instead of a pointer to an invalid context.

How a context goes invalid is backend specific. It could happen due to device loss, or any other unrecoverable error.

Returns
  If the context is valid.

Implements impeller::Context.

Definition at line 449 of file context_vk.cc.

449 {
450 return is_valid_;
451 }

## ◆ SetDebugName() [1/2]

template<typename T >

static bool impeller::ContextVK::SetDebugName | ( | const vk::Device & | device,
|  | T | handle,
|  | std::string_view | label
| ) |  |
| inline static

Definition at line 101 of file context_vk.h.

103 {
104 if (!HasValidationLayers()) {
105 // No-op if validation layers are not enabled.
106 return true;
107 }
108
109 auto c_handle = static_cast<typename T::CType>(handle);
110
111 vk::DebugUtilsObjectNameInfoEXT info;
112 info.objectType = T::objectType;
113 info.pObjectName = label.data();
114 info.objectHandle = reinterpret_cast<decltype(info.objectHandle)>(c_handle);
115
116 if (device.setDebugUtilsObjectNameEXT(info) != vk::Result::eSuccess) {
117 VALIDATION_LOG << "Unable to set debug name: " << label;
118 return false;
119 }
120
121 return true;
122 }

References impeller::HasValidationLayers(), and VALIDATION_LOG.

## ◆ SetDebugName() [2/2]

template<typename T >

bool impeller::ContextVK::SetDebugName | ( | T | handle,
|  | std::string_view | label
| ) |  | const
| inline

Definition at line 96 of file context_vk.h.

96 {
97 return SetDebugName(GetDevice(), handle, label);
98 }

References GetDevice().

Referenced by impeller::CreateCompatRenderPassForPipeline(), and impeller::QueuesVK::QueuesVK().

## ◆ SetOffscreenFormat()

void impeller::ContextVK::SetOffscreenFormat | ( | PixelFormat | pixel_format | ) |

Definition at line 440 of file context_vk.cc.

440 {
441 CapabilitiesVK::Cast(*device_capabilities_).SetOffscreenFormat(pixel_format);
442 }

References impeller::BackendCast< CapabilitiesVK, Capabilities >::Cast(), and impeller::CapabilitiesVK::SetOffscreenFormat().

## ◆ SetSyncPresentation()

void impeller::ContextVK::SetSyncPresentation | ( | bool | value | ) |
| inline override virtual

Force the Vulkan presentation (submitKHR) to be performed on the raster task runner.

This is required for correct rendering on Android when using the hybrid composition mode. This has no effect on other backends.

Reimplemented from impeller::Context.

Definition at line 89 of file context_vk.h.

89 { sync_presentation_ = value; }

## ◆ Shutdown()

void impeller::ContextVK::Shutdown | ( |  | ) |
| override virtual

Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops.

Implements impeller::Context.

Definition at line 489 of file context_vk.cc.

489 {
490 // There are multiple objects, for example |CommandPoolVK|, that in their
491 // destructors make a strong reference to |ContextVK|. Resetting these shared
492 // pointers ensures that cleanup happens in a correct order.
493 //
494 // tl;dr: Without it, we get thread::join failures on shutdown.
495 fence_waiter_.reset();
496 resource_manager_.reset();
497
498 raster_message_loop_->Terminate();
499 }

The documentation for this class was generated from the following files:

- impeller/renderer/backend/vulkan/context_vk.h
- impeller/renderer/backend/vulkan/context_vk.cc

impeller::CapabilitiesVK::SetOffscreenFormat
void SetOffscreenFormat(PixelFormat pixel_format) const
Definition: capabilities_vk.cc:337
impeller::CommandPoolRecyclerVK::DestroyThreadLocalPools
static void DestroyThreadLocalPools(const ContextVK *context)
Clean up resources held by all per-thread command pools associated with the given context.
Definition: command_pool_vk.cc:244
impeller::QueuesVK::graphics_queue
std::shared_ptr< QueueVK > graphics_queue
Definition: queue_vk.h:58
impeller::ContextVK::SetDebugName
bool SetDebugName(T handle, std::string_view label) const
Definition: context_vk.h:96
VALIDATION_LOG
#define VALIDATION_LOG
Definition: validation.h:60
impeller::Context::BackendType::kVulkan
@ kVulkan
impeller::ContextVK::GetDevice
const vk::Device & GetDevice() const
Definition: context_vk.cc:480
impeller::BackendCast< CapabilitiesVK, Capabilities >::Cast
static CapabilitiesVK & Cast(Capabilities &base)
Definition: backend_cast.h:14
impeller::HasValidationLayers
bool HasValidationLayers()
Definition: context_vk.cc:40